Summary:   Firmware update daemon
Name:      fwupd-qubes
Version:   1.8.17
Release:   2%{?dist}
License:   LGPLv2+
URL:       https://github.com/fwupd/fwupd
Source0:   fwupd-%{version}.tar.xz
Source1:   meson.build
Patch1: 0001-qubes-change-symlink-to-be-relative.patch
Patch2: 0002-qubes-make-fwupdmgr-get-updates-think-it-s-interacti.patch
Patch3: 0003-qubes-Drop-custom-vendor-and-version-check.patch
Patch4: 0004-qubes-do-not-use-deprecated-imp-module-in-tests.patch
Patch5: 0005-qubes-fix-checking-for-whonix-in-tests.patch
BuildArch: noarch

BuildRequires: meson
BuildRequires: gcc

%description
fwupd is a daemon to allow session software to update device firmware.

%package dom0
Summary: fwupd wrapper for Qubes OS - dom0 scripts
Requires:   gcab
Requires:   fwupd >= 1.5.7
Requires:   libjcat >= 0.1.6
Requires:   python3-packaging
Requires:   sequoia-sqv

%description dom0
fwupd wrapper for Qubes OS

%package vm
Summary: fwupd wrapper for Qubes OS - VM scripts
Requires:   gcab
Requires:   fwupd >= 1.5.7
Requires:   libjcat >= 0.1.6
Requires:   python3-packaging

%description vm
fwupd wrapper for Qubes OS

%prep
%autosetup -p1 -n fwupd-%{version}
#override meson.build to handle just qubes part
cp %{SOURCE1} ./
grep qubes meson_options.txt > meson_options.txt.new
mv -f meson_options.txt.new meson_options.txt

%build

%if 0%{?fedora} >= 34
%meson \
    -Dqubes=true

%meson_build
%endif

%install
%if 0%{?fedora} >= 34
%meson_install
%else
# meson too old, install relevant parts manually (to be dropped later)
cd contrib/qubes
install -d $RPM_BUILD_ROOT/usr/share/qubes-fwupd/src
install -t $RPM_BUILD_ROOT/usr/share/qubes-fwupd/src src/*.py
cp -r test $RPM_BUILD_ROOT/usr/share/qubes-fwupd/test
install -d $RPM_BUILD_ROOT/usr/libexec/qubes-fwupd
install -t $RPM_BUILD_ROOT/usr/libexec/qubes-fwupd src/vms/*.py
install -d $RPM_BUILD_ROOT/usr/sbin
ln -s ../share/qubes-fwupd/src/qubes_fwupdmgr.py \
    $RPM_BUILD_ROOT/usr/sbin/qubes-fwupdmgr
%endif

%files vm
%{_libexecdir}/qubes-fwupd/fwupd_common_vm.py
%{_libexecdir}/qubes-fwupd/fwupd_download_updates.py

%files dom0
%{_datadir}/qubes-fwupd/src/fwupd_receive_updates.py
%{_sbindir}/qubes-fwupdmgr
%{_datadir}/qubes-fwupd/src/qubes_fwupdmgr.py
%{_datadir}/qubes-fwupd/src/qubes_fwupd_common.py
%{_datadir}/qubes-fwupd/src/qubes_fwupd_heads.py
%{_datadir}/qubes-fwupd/src/qubes_fwupd_update.py
%{_datadir}/qubes-fwupd/src/__init__.py
%{_datadir}/qubes-fwupd/test/fwupd_logs.py
%{_datadir}/qubes-fwupd/test/test_qubes_fwupdmgr.py
%{_datadir}/qubes-fwupd/test/test_qubes_fwupd_heads.py
%{_datadir}/qubes-fwupd/test/__init__.py
%{_datadir}/qubes-fwupd/test/logs/get_devices.log
%{_datadir}/qubes-fwupd/test/logs/get_updates.log
%{_datadir}/qubes-fwupd/test/logs/help.log
%{_datadir}/qubes-fwupd/test/logs/firmware.metainfo.xml
%{_datadir}/qubes-fwupd/test/logs/metainfo_name/firmware.metainfo.xml
%{_datadir}/qubes-fwupd/test/logs/metainfo_version/firmware.metainfo.xml

%changelog
* Tue Apr 30 2024 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-fwupd.git

* Tue Apr 30 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0de5eec
- version 1.8.17-2

* Mon Apr 29 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d9c032b
- Fix patches from previous update, and a failed rebase

* Mon Apr 29 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2668236
- version 1.8.17-1

* Sun Apr 28 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 21d2202
- Do not use deprecated 'imp' library in tests

* Sun Apr 28 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c759364
- Remove extra vendor/version check from the qubes-fwupdmgr wrapper

* Sun Apr 28 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - db1e905
- Update to 1.8.17

* Sat Apr 27 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 923abd6
- Update signing key

* Tue Apr 16 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 73cf5c8
- Fix interactive prompt from fwupdmgr get-updates

* Sun Dec 03 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5bbe561
- version 1.8.14-5

* Fri Dec 01 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4e78cce
- Make vendor check case-insensitive

* Thu Oct 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6564968
- version 1.8.14-4

* Sat Oct 21 2023 Yanase Yuki <dev@zpc.st> - 186985e
- fix patch which wrongly delete _get_dom0_devices()

* Sat Jul 01 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9485f46
- version 1.8.14-3

* Fri Jun 23 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 121ec22
- Make 'fwupdmgr get-updates' call think it's "interactive"

* Sat May 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 08232d3
- version 1.8.14-2

* Sat May 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d882ea7
- fix vendor check and make it optional

* Fri May 19 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c3fc4e1
- Convert symlink to relative

* Fri May 19 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 172f12c
- Add CI

* Fri May 19 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4e8a8dd
- Package qubes-specific part in fwupd

